#include<bits/stdc++.h>
#define x first
#define y second

using namespace std;

int n, m, group;
int **a;
set<int> *h, *v;
int *bh, *bv;
map<int, vector<pair<int, int>>> mp;
map<int, pair<int, int>> ans;

map<int, vector<int>> g;
map<int, bool> used;
vector<int> order;

void dfs(int v){
    used[v] = true;
    for(int u : g[v])
        if(!used[u])
            dfs(u);
    order.push_back(v);
}

int main(){
    ios_base::sync_with_stdio(false);
    cout.tie(0);
    cin.tie(0);
    cin >> n >> m >> group;
    a = new int*[n];
    for(int i = 0; i < n; ++i){
        a[i] = new int[m];
        for(int j = 0; j < m; ++j)
            cin >> a[i][j];
    }
    h = new set<int>[n];
    v = new set<int>[m];
    bh = new int[n];
    for(int i = 0; i < n; ++i)
        bh[i] = 0;
    bv = new int[m];
    for(int j = 0; j < m; ++j)
        bv[j] = 0;
    for(int i = 0; i < n; ++i)
        for(int j = 0; j < m; ++j){
            if(!a[i][j]){
                bh[i] = -1;
                bv[j] = -1;
            }
            else mp[a[i][j]].push_back({i, j});
        }
    set<int> unblocked;
    for(auto el : mp){
        int num = el.x;
        vector<pair<int, int>> s = el.y;
        if(s.size() == 1){
            int i = s[0].x,
                j = s[0].y;
            if(bh[i]){
                bv[j] = num;
                ans[num] = {1, j};
            }
            else if(bv[j]){
                bh[i] = num;
                ans[num] = {0, i};
            }
            else{
                h[i].insert(num);
                v[j].insert(num);
                unblocked.insert(num);
            }
            continue;
        }
        int i1 = s[0].x,
            j1 = s[0].y,
            i2 = s[1].x,
            j2 = s[1].y;
        if(i1 == i2){
            bh[i1] = num;
            ans[num] = {0, i1};
        }
        else{
            bv[j1] = num;
            ans[num] = {1, j1};
        }
    }
    while(!unblocked.empty()){
        int num = *unblocked.begin();
        vector<int> changed;
        changed.push_back(num);
        while(!changed.empty()){
            unblocked.erase(changed.back());
            changed.pop_back();
            int i = mp[num][0].x,
                j = mp[num][0].y;
            if(!bh[i]){
                bh[i] = num;
                ans[num] = {0, i};
                h[i].erase(num);
                for(int el : h[i])
                    changed.push_back(el);
                v[j].erase(num);
                if(v[j].size() == 1)
                    changed.push_back(*v[j].begin());
            }
            else if(!bv[i]){
                bv[j] = num;
                ans[num] = {1, j};
                v[j].erase(num);
                for(int el : v[j])
                    changed.push_back(el);
                h[i].erase(num);
                if(h[i].size() == 1)
                    changed.push_back(*h[i].begin());
            }
            break;
        }
    }
    vector<int> all;
    for(int i = 0; i < n; ++i)
        for(int j = 0; j < m; ++j){
            if(!a[i][j])
                continue;
            all.push_back(a[i][j]);
            if(bh[i] != a[i][j] && bh[i] > 0)
                g[a[i][j]].push_back(bh[i]);
            if(bv[j] != a[i][j] && bv[j] > 0)
                g[a[i][j]].push_back(bv[j]);
        }
    for(int el : all)
        if(!used[el])
            dfs(el);
    cout << order.size() << '\n';
    for(int el : order)
        cout << ans[el].x << ' ' << ans[el].y+1 << ' ' << el << '\n';
}
