#include <iostream>
#include <algorithm>
#include <cstdio>

using namespace std;

int n, m, g;

void g1() {
    bool isM1 = true;
    if (n == 1) {
        isM1 = false;
        n = m;
        m = 1;
    }
    pair<int, int> colors[n];
    int empty_color = 0;
    pair<int, int> a[n];
    for (int i = 0; i < n; ++ i) {
        int k;
        cin >> k;
        a[i].first = k;
        a[i].second = i;
        colors[i].second = 0;
    }
    sort (a, a + n);
    if (a[n - 1].first == 0) {
        cout << 0 << endl;
        return;
    }
    int q = 0;
    int cur_col = a[n - 1].first;
    colors[0].first = 0;
    for (int i = n - 1; i > -1; -- i) {
        if (a[i].first == 0) {
            colors[empty_color].second = i + 1;
            break;
        }
        if (a[i].first == cur_col) {
            colors[empty_color].first ++;
        } else {
            colors[empty_color].second = i + 1;
            cur_col = a[i].first;
            empty_color ++;
            colors[empty_color].first = 1;
        }
        q ++;
    }
    sort(colors, colors + empty_color + 1);
    if (q == n) {
        cout << n - colors[empty_color].first + 1 << endl;
        int row_col = a[colors[empty_color].second].first;
        cout << isM1 << " " << 1 << " " << row_col << endl;
        for (int i = 0; i < n; ++ i) {
            if (a[i].first == row_col) {
                continue;
            }
            cout << !isM1 << " " << a[i].second + 1 << " " << a[i].first << endl;
        }
    } else {
        cout << q << endl;
        for (int i = n - 1; i > -1; -- i) {
            if (a[i].first == 0) {
                break;
            }
            cout << !isM1 << " " << a[i].second + 1 << " " << a[i].first << endl;
        }
    }
}

void g2() {
    if (n == 1 || m == 1) {
        g1();
        return;
    }
    int a[n][m];
    int colored_pixels_amount_row[n];
    int colored_pixels_amount_col[m];
    for (int i = 0; i < n; ++ i) {
        colored_pixels_amount_row[i] = 0;
        for (int j = 0; j < m; ++ j) {
            if (!i) {
                colored_pixels_amount_col[j] = 0;
            }
            cin >> a[i][j];
            if (a[i][j] != 0) {
                colored_pixels_amount_row[i] ++;
                colored_pixels_amount_col[j] ++;
            }
        }
    }
    sort(colored_pixels_amount_col, colored_pixels_amount_col + m);
    sort(colored_pixels_amount_row, colored_pixels_amount_row + n);
    bool are_rows_colored = colored_pixels_amount_col[0];
    bool are_cols_colored = colored_pixels_amount_row[0];
    if (!are_cols_colored && !are_rows_colored) {
        cout << 0 << endl;
        return;
    }
    if (!are_cols_colored && are_rows_colored) {
        cout << colored_pixels_amount_col[0] << endl;
        for (int i = 0; i < n; ++ i) {
            if (a[i][0] == 0) {
                continue;
            }
            cout << 0 << " " << i + 1 << " " << a[i][0] << endl;
        }
    }
    if (are_cols_colored && !are_rows_colored) {
        cout << colored_pixels_amount_row[0] << endl;
        for (int i = 0; i < m; ++ i) {
            if (a[0][i] == 0) {
                continue;
            }
            cout << 0 << " " << i + 1 << " " << a[0][i] << endl;
        }
    }
    if (are_cols_colored && are_rows_colored) {
        int empty_col = 0;
        int empty_row = 0;
        if (a[0][0] != 0 && a[0][1] != 0) {
            empty_row = 1;
        }
        if (a[0][0] != 0 && a[1][0] != 0) {
            empty_col = 1;
        }
        cout << 2 << endl;
        int filled_col = 0;
        int filled_row = 0;
        for (; a[empty_row][filled_col] == 0; ++ filled_col);
        for (; a[filled_row][empty_col] == 0; ++ filled_row);
        bool is_col_first = a[filled_row][empty_col] == a[filled_row][filled_col];
        if (is_col_first) {
            cout << 1 << " " << filled_col + 1 << " " << a[empty_row][filled_col] << endl;
            cout << 0 << " " << filled_row + 1 << " " << a[filled_row][empty_col] << endl;
        } else {
            cout << 0 << " " << filled_row + 1 << " " << a[filled_row][empty_col] << endl;
            cout << 1 << " " << filled_col + 1 << " " << a[empty_row][filled_col] << endl;
        }
    }
}

void g3() {
    if (n == 1 || m == 1) {
        g1();
        return;
    }
    int a[n][m];
    int empty_col = -1;
    int empty_row = -1;
    for (int i = 0; i < n; ++ i) {
        for (int j = 0; j < m; ++ j) {
            cin >> a[i][j];
            if (a[i][j] == 0) {
                empty_col = j;
                empty_row = i;
            }
        }
    }
    if (empty_col == -1) {
        if (a[0][0] == a[0][1]) {
            cout << n << endl;
            for (int i = 0; i < n; ++ i) {
                cout << 0 << " " << i + 1 << " " << a[i][0] << endl;
            }
        } else {
            cout << m << endl;
            for (int i = 0; i < m; ++ i) {
                cout << 1 << " " << i + 1 << " " << a[0][i] << endl;
            }
        }
    }

}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin >> n >> m >> g;
    if (g == 1) {
        g1();
        return 0;
    }
    if (g == 2) {
        g2();
        return 0;
    }
    if (g == 3) {
        //g3();
        return 0;
    }
}
